# By default, use official Espressif image
image: espressif/idf:release-v4.3

variables:
    GIT_SUBMODULE_STRATEGY: recursive
    APP_NAME: "sensor_demo"

stages:
  - build

.common_artifacts:
    artifacts:
        name: "${CI_PROJECT_NAME}___${CI_COMMIT_REF_SLUG}_${CI_COMMIT_SHORT_SHA}"
        paths:
            - example/build/bootloader/bootloader.bin
            - example/build/partition_table/partition-table.bin
            - example/build/${APP_NAME}.bin
  
# When pushing to mater or merge request build it, but not let artifacts too
# long here
build_fw_master_mr:
    stage: build
    # Need Docker for that
    tags:
        - docker
    only:
        - master
        - merge_requests
    script:
        - cd example && idf.py build
    artifacts:
        expire_in: 3 months
    extends:
        - .common_artifacts
    

# When tagging, then it is "release" and want to keep artifacts bit longer
build_fw_tag:
    stage: build
    # Need Docker for that
    tags:
        - docker
    only:
        - tag
    script:
        - cd example && idf.py build
    artifacts:
        expire_in: never
    extends:
        - .common_artifacts
